## gfal2 2.10.2

=== CMakeLists.txt ===
## cmake build script for srm-ifce
project (gfal2)
cmake_minimum_required (VERSION 2.6)
message ("cmake source dir : ${CMAKE_SOURCE_DIR}")

# default set of options
set (MAIN_CORE      TRUE CACHE STRING "enable compilation of the main library")
set (MAIN_TRANSFER  TRUE CACHE STRING "enable compilation of the transfer library")
set (PLUGIN_LFC     TRUE CACHE STRING "enable compilation of the lfc plugin")
set (PLUGIN_SRM     TRUE CACHE STRING "enable compilation of the srm plugin")
set (PLUGIN_RFIO    TRUE CACHE STRING "enable compilation of the RFIO plugin")
set (PLUGIN_DCAP    TRUE CACHE STRING "enable compilation of the DCAP plugin")
set (PLUGIN_FILE    TRUE CACHE STRING "enable compilation of the local File plugin")
set (PLUGIN_GRIDFTP TRUE CACHE STRING "enable compilation of the GRIDFTP plugin")
set (PLUGIN_HTTP    TRUE CACHE STRING "enable compilation of the HTTP plugin")
set (PLUGIN_XROOTD  TRUE CACHE STRING "enable compilation of the XROOTD plugin")
set (PLUGIN_MOCK    FALSE CACHE STRING "enable compilation of the MOCK plugin")

# build type
set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "type of build")

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

# load modules
include(DefineInstallationPaths REQUIRED)
include(MacroCopyFile REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(CMakeCXX11Support REQUIRED)

# Enable C++11 support
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

# enable testing
include (CTest)

#define PROJECT vars
set (PROJECT_NAME_MAIN "gfal2")
set (OUTPUT_NAME_MAIN "gfal2")

set (PROJECT_NAME_TRANSFER "gfal_transfer")
set (OUTPUT_NAME_TRANSFER "gfal_transfer")

set (VERSION_MAJOR  2)
set (VERSION_MINOR  10)
set (VERSION_PATCH  2)
set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

add_definitions(-DVERSION="${VERSION_STRING}")

# out of project test compilation
set (ONLY_TESTS FALSE CACHE STRING "build only the tests")
set (SKIP_TESTS FALSE CACHE STRING "skip the tests")

# libs checks
find_package (GLIB2 REQUIRED)
find_package (GTHREAD2 REQUIRED)

# include directories
include_directories (${GLIB2_INCLUDE_DIRS})
include_directories (${GTHREAD2_INCLUDE_DIRS})
include_directories (${CMAKE_SOURCE_DIR}/src/core)
include_directories (${CMAKE_SOURCE_DIR}/src/utils)

# Core and plugins
if (NOT ONLY_TESTS)
    
    # general parameters for configuration
    add_definitions ( -DGFAL_PLUGIN_DIR_DEFAULT="${PLUGIN_INSTALL_DIR}" )
    add_definitions ( -DGFAL_CONFIG_DIR_DEFAULT="${SYSCONF_INSTALL_DIR}" )
    # add file offset 64 for 32 bits
    add_definitions ( -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_GNU_SOURCE)

    #install doc license
    install (FILES "LICENSE" "README.md" "RELEASE-NOTES" "DESCRIPTION" "readme.html"
			 DESTINATION ${DOC_INSTALL_DIR})
			
    # install global configuration files
    list (APPEND lst_conf_files "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/gfal2_core.conf" "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/bdii.conf")
    install (FILES ${lst_conf_files}
             DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

    add_subdirectory (doc)
    add_subdirectory (src)

endif (NOT ONLY_TESTS)

if (NOT SKIP_TESTS)
    add_subdirectory (test)
endif (NOT SKIP_TESTS)

=== doc/CMakeLists.txt ===

SET(MAIN_DOC TRUE
	CACHE STRING "enable installation of the main library documentation")	

IF(MAIN_DOC)

	file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/build/html/")
	addDoxyGeneration("Doxyfile.in")

	install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/build/html/"
			DESTINATION ${DOC_INSTALL_DIR}/html/)

	install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/examples/"
			DESTINATION ${DOC_INSTALL_DIR}/examples)

ENDIF(MAIN_DOC)



install(FILES "mans/gfal2_version.1"
		DESTINATION ${MAN_INSTALL_DIR}/man1/) # install examples

=== packaging/Makefile ===
NAME=gfal2
SPEC=rpm/$(NAME).spec
VERSION=${shell grep '^Version:' $(SPEC) | awk '{print $$2}' }
# Leave blank. To be overriden by CI tools.
RELEASE=

CWD=${shell pwd}

RPMBUILD=/tmp/rpmbuild
SRPMS=$(CWD)
RPMS=$(CWD)/out

MOCK_CHROOT=epel-6-cernonly-x86_64
MOCK_FLAGS=--verbose


RPMDEFINES_SRC=--define='_topdir $(RPMBUILD)' \
	--define='_sourcedir $(CWD)' \
	--define='_builddir %{_topdir}/BUILD' \
	--define='_srcrpmdir $(SRPMS)' \
	--define='_rpmdir $(RPMS)' \
    --define "_source_filedigest_algorithm md5" \
    $(RPMBUILD_SRC_EXTRA_FLAGS)

RPMDEFINES_BIN=--define='_topdir $(RPMBUILD)' \
	--define='_sourcedir %{_topdir}/SOURCES' \
	--define='_builddir %{_topdir}/BUILD' \
	--define='_srcrpmdir $(SRPMS).' \
	--define='_rpmdir $(RPMS)' \
    --define "_binary_filedigest_algorithm md5" \
    $(RPMBUILD_BIN_EXTRA_FLAGS)


PBUILDER_FLAGS=
PBUILDER_TMP="/tmp/"


all: srpm

clean:
	rm -fv *.tar
	rm -fv *.tar.gz
	rm -fv *.rpm
	rm -fv *.log
	rm -rfv out
	rm -fv *.deb
	rm -fv *.gz
	rm -fv *.dsc
	rm -fv *.changes
	rm -rfv "$(RPMBUILD)"

dist: clean
	tar vczf "$(NAME)-$(VERSION).tar.gz" --exclude="packaging" --exclude=".git" --exclude="*.pyc" --transform="s,^,$(NAME)-$(VERSION)/," ..

$(RPMBUILD):
	mkdir -p "$(RPMBUILD)"

override_release: $(SPEC)
	$(if $(RELEASE), sed -i "s/Release:.*/Release: $(RELEASE)%{?dist}/g" "$(SPEC)")

srpm: dist $(SPEC) $(RPMBUILD) override_release
	/usr/bin/rpmbuild --nodeps -bs $(RPMDEFINES_SRC) $(SPEC)

rpm: srpm
	/usr/bin/rpmbuild --rebuild $(RPMDEFINES_BIN) $(NAME)-$(VERSION)-*.src.rpm

mock: srpm
	/usr/bin/mock $(MOCK_FLAGS) -r $(MOCK_CHROOT) $(NAME)-$(VERSION)-*.src.rpm

deb-src: dist
	rm -rf "$(PBUILDER_TMP)/$(NAME)-$(VERSION)"
	tar xzf "$(NAME)-$(VERSION).tar.gz" -C "$(PBUILDER_TMP)"
	cp -rv debian "$(PBUILDER_TMP)/$(NAME)-$(VERSION)"
	$(if $(RELEASE), sed -ri "s/($(NAME) )\((([0-9]+\.)+[0-9]+)-[0-9]+\)/\\1(\\2-$(RELEASE))/g" "$(PBUILDER_TMP)/$(NAME)-$(VERSION)/debian/changelog")
	cp -f "$(NAME)-$(VERSION).tar.gz" "$(PBUILDER_TMP)/$(NAME)_$(VERSION).orig.tar.gz" 
	cd "$(PBUILDER_TMP)/$(NAME)-$(VERSION)"; \
		debuild -us -uc -S
	mv $(PBUILDER_TMP)/$(NAME)_$(VERSION)*.gz .
	mv $(PBUILDER_TMP)/$(NAME)_$(VERSION)*.dsc .

deb: deb-src
	pbuilder build $(PBUILDER_FLAGS) $(NAME)_$(VERSION)*.dsc

=== test/CMakeLists.txt ===

set (UNIT_TESTS       FALSE CACHE STRING "enable compilation of unit tests")
set (FUNCTIONAL_TESTS FALSE CACHE STRING "functional tests for gfal ")
set (STRESS_TESTS     FALSE CACHE STRING "stress tests for gfal ")

include_directories (${CMAKE_SOURCE_DIR}/src)

if (ONLY_TESTS)
    find_package (GFAL2 REQUIRED)
    include_directories (${GFAL2_INCLUDE_DIRS})
else (ONLY_TESTS)
    set(GFAL2_LIBRARIES gfal2 gfal2_transfer)
endif (ONLY_TESTS)

find_package(GTEST)
include_directories(${GTEST_INCLUDE_DIR})

execute_process(COMMAND cmake -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/conf_test  ${CMAKE_CURRENT_BINARY_DIR}/conf_test) 

# Common methods for the tests
add_subdirectory(common)

# Tests
if (UNIT_TESTS)
    add_subdirectory(unit)
endif (UNIT_TESTS)

if (FUNCTIONAL_TESTS)
    add_subdirectory(functional)
endif (FUNCTIONAL_TESTS)

if (STRESS_TESTS)
    add_subdirectory(stress-test)
endif (STRESS_TESTS)

=== src/core/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

# Sources needed for the core library
file (GLOB src_cancel     "cancel/*.c*")
file (GLOB src_common     "common/*.c" "common/future/*.c")
file (GLOB src_config     "config/*.c")
file (GLOB src_exceptions "exceptions/*.c*")
file (GLOB src_gconfig    "g_config_manager/*.c*")
file (GLOB src_file       "file/*.c*")
file (GLOB src_global     "global/*c*")
file (GLOB src_logger     "logger/*.c*")
file (GLOB src_posix      "posix/*.c*")

# Core library
add_definitions(-D__GFAL2_BUILD__)

add_library (gfal2 SHARED ${src_cancel}
                          ${src_common}
                          ${src_config}
                          ${src_gconfig}
                          ${src_file}
                          ${src_global}
                          ${src_logger}
                          ${src_posix}
                          ${src_exceptions}
                          ${gfal2_utils_c_src})

target_link_libraries (gfal2 "stdc++" ) # hotfix for libc TLS init bug in EPEL 5
target_link_libraries (gfal2 ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES})
target_link_libraries (gfal2 "dl")

set_target_properties (gfal2 PROPERTIES
                             VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                             SOVERSION ${VERSION_MAJOR}
                             CLEAN_DIRECT_OUTPUT 1
                             OUTPUT_NAME ${OUTPUT_NAME_MAIN})

# pkgconfig for gfal2
add_PkgConfigFile_for_Library ("gfal2.pc" gfal2
                                        HEADER_DIRS "gfal2"
                                        CFLAGS " -D_FILE_OFFSET_BITS=64 "
                                        DESCRIPTION "GFAL 2.0 pkgconfig file"
                                        REQUIRES "glib-2.0")

# Install core library
install (TARGETS gfal2 LIBRARY DESTINATION ${LIB_INSTALL_DIR})
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal2.pc DESTINATION ${PKGCONFIG_FILES_DIR})

# Install development headers
install (FILES "gfal_api.h" "gfal_plugins_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/)
install (FILES "cancel/gfal_cancel.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/cancel)
install (FILES "logger/gfal_logger.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/logger)
install (FILES "posix/gfal_posix_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/posix)
install (FILES "common/gfal_constants.h"
               "common/gfal_common_plugin_interface.h"
               "common/gfal_prototypes.h"
               "common/gfal_common_plugin.h"
               "common/gfal_types.h"
               "common/gfal_deprecated.h"
               "common/gfal_common_err_helpers.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/common)
install (FILES "global/gfal_global.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/global)
install (FILES "config/gfal_config.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/config)
install (FILES "g_config_manager/g_config_manager.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/g_config_manager)
install (FILES "file/gfal_file_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/file)
install (FILES "fdesc/gfal_file_handle.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/fdesc)

# Transfer library
if (MAIN_TRANSFER)
    add_subdirectory (transfer)
endif (MAIN_TRANSFER)

=== src/plugins/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

link_directories(${CMAKE_CURRENT_BINARY_DIR}/../core)

add_subdirectory (dcap)
add_subdirectory (file)
add_subdirectory (gridftp)
add_subdirectory (http)
add_subdirectory (lfc)
add_subdirectory (rfio)
add_subdirectory (srm)
add_subdirectory (xrootd)
add_subdirectory (mock)

=== src/utils/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

file (GLOB src_exceptions   "exceptions/*.c*")
file (GLOB src_gsimplecache "gsimplecache/*.c*")
file (GLOB src_uri          "uri/*.c*")
file (GLOB src_checksums    "${CMAKE_CURRENT_SOURCE_DIR}/checksums/*.c*")

LIST(APPEND gfal2_utils_src ${src_exceptions})

LIST(APPEND gfal2_utils_c_src   ${src_gsimplecache}
                                ${src_uri}
                                ${src_checksums})

add_subdirectory (mds)

set(gfal2_mds_src ${gfal2_mds_src} PARENT_SCOPE)
set(gfal2_utils_c_src ${gfal2_utils_c_src} PARENT_SCOPE)
set(gfal2_src_checksum ${src_checksums}    PARENT_SCOPE)

set(mds_cache_link ${mds_cache_link} PARENT_SCOPE)
set(is_ifce_link  ${is_ifce_link} PARENT_SCOPE )
set(gfal2_utils_src ${gfal2_utils_src} PARENT_SCOPE)
set(gfal2_mds_def ${gfal2_mds_def} PARENT_SCOPE)

install (FILES "uri/gfal_uri.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/utils)

=== test/common/CMakeLists.txt ===
add_library(gfal2_test_shared SHARED gfal_lib_test.c gfal_gtest_asserts.cpp)
target_link_libraries (gfal2_test_shared ${GFAL2_LIBRARIES} ${GTEST_LIBRARIES})

if (FUNCTIONAL_TESTS)
    install (TARGETS gfal2_test_shared LIBRARY
        DESTINATION ${LIB_INSTALL_DIR})
endif ()

=== test/functional/CMakeLists.txt ===
function (add_test_executable name source)
    add_executable(${name} ${source})
    install(TARGETS ${name}
            DESTINATION ${SHARE_INSTALL_PREFIX}/gfal2/tests)
endfunction(add_test_executable name)


if(FUNCTIONAL_TESTS)
        find_package(GTEST)

        include_directories(
            "${CMAKE_SOURCE_DIR}/src"
            "${CMAKE_SOURCE_DIR}/test"
            "${CMAKE_SOURCE_DIR}/src/posix/"
            "${GLIB2_INCLUDE_DIRS}"
            "${GTEST_INCLUDE_DIR}"
        )
        
        # Bring online tests
        add_test_executable(gfal_test_bringonline "gfal_test_bringonline.cpp")
        target_link_libraries(gfal_test_bringonline ${GFAL2_LIBRARIES} gfal2_test_shared)
        
        function(test_bringonline name dir_path)
            add_test(gfal_test_bringonline_${name} gfal_test_bringonline ${dir_path})
        endfunction(test_bringonline name valid_file)

        # Checksum tests
        add_test_executable(gfal_test_checksum "gfal_test_checksum.cpp")
        target_link_libraries(gfal_test_checksum ${GFAL2_LIBRARIES} gfal2_test_shared)
        
        function(checksum_test_simple name dir_path algo)
            add_test(gfal_checksum_simple_${name} gfal_test_checksum ${dir_path} ${algo})
        endfunction(checksum_test_simple name valid_file algo)
        
        # Stat tests
        add_test_executable(gfal_test_stat "gfal_test_stat.c")
        target_link_libraries(gfal_test_stat ${GFAL2_LIBRARIES} gfal2_test_shared)
        
        function(stat_test_all name valid)
            add_test(gfal_stat_${name} gfal_test_stat ${valid})
        endfunction(stat_test_all valid)
        
        # Deletion tests
        add_test_executable(gfal_test_del_nonex "gfal_test_del_nonex.c")
        target_link_libraries(gfal_test_del_nonex ${GFAL2_LIBRARIES} gfal2_test_shared)
        
        add_test_executable(gfal_test_del "gfal_test_del.cpp") 
        target_link_libraries(gfal_test_del ${GFAL2_LIBRARIES} gfal2_test_shared)
        
        add_test_executable(gfal_test_mkdir_unlink "gfal_test_mkdir_unlink.c")
        target_link_libraries(gfal_test_mkdir_unlink ${GFAL2_LIBRARIES} gfal2_test_shared)

        function(test_gfal_test_del_nonex name dir_path)
            add_test(gfal_test_del_nonex_${name} gfal_test_del_nonex ${dir_path})
        endfunction(test_gfal_test_del_nonex name path)        

        function(test_gfal_test_del name dir_path)
            add_test(gfal_test_del_${name} gfal_test_del ${dir_path})
        endfunction(test_gfal_test_del name path)        

        function (test_gfal_test_mkdir_unlink name dir_path)
            add_test(gfal_test_mkdir_unlink_${name} gfal_test_mkdir_unlink ${dir_path})
        endfunction (test_gfal_test_mkdir_unlink name path)        

        # Chmod tests
        add_test_executable(gfal_test_chmod "gfal_test_chmod.cpp")
        target_link_libraries(gfal_test_chmod ${GFAL2_LIBRARIES} gfal2_test_shared)
        
        function(chmod_test_all name valid right1 right2 right3 right4)
            add_test(gfal_test_right_change_${name} gfal_test_chmod ${valid} ${right1} ${right2} ${right3} ${right4})
        endfunction(chmod_test_all name valid right1 right2 right3 right4)        
        
        # Rmdir tests
        add_test_executable(gfal_test_rmdir_full "gfal_test_rmdir_full.cpp")
        target_link_libraries(gfal_test_rmdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

        function(rmdir_test_all name valid_dir)
            add_test(gfal_test_rmdir_full_${name} gfal_test_rmdir_full ${valid_dir})
        endfunction(rmdir_test_all name valid_dir)
        
        # Readdir tests
        add_test_executable(gfal_test_readdir_full "gfal_test_readdir_full.cpp")
        target_link_libraries(gfal_test_readdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)
        
        function(test_readdir_full name valid)
                add_test(gfal_test_readdir_full_${name} gfal_test_readdir_full ${valid})
        endfunction(test_readdir_full valid)        

        # IO tests
        add_test_executable(gfal_test_rw_full "gfal_test_rw_full.cpp")
        target_link_libraries(gfal_test_rw_full ${GFAL2_LIBRARIES} gfal2_test_shared)
            
        add_test_executable(gfal_test_rw_seq "gfal_test_rw_seq.cpp")
        target_link_libraries(gfal_test_rw_seq ${GFAL2_LIBRARIES} gfal2_test_shared)
        
        add_test_executable(gfal_test_rw_seek "gfal_test_rw_seek.cpp")
        target_link_libraries(gfal_test_rw_seek ${GFAL2_LIBRARIES} gfal2_test_shared) 
        
        function(rwt_test_all name path size)
            add_test(gfal_rw_size_${name} gfal_test_rw_full ${path} ${size})
        endfunction(rwt_test_all name path size)
        
        function(rwt_test_seq name path size_read size)
            add_test(gfal_rw_seq_${name} gfal_test_rw_seq ${path} ${size_read} ${size})
        endfunction(rwt_test_seq name path size_read size)
        
        function(rwt_test_seek name path size_read size)
            add_test(gfal_rw_seek_${name} gfal_test_rw_seek ${path} ${size_read} ${size})
        endfunction(rwt_test_seek name path size) 

        # Mkdir tests
        add_test_executable(gfal_test_mkdir_full "gfal_test_mkdir_full.cpp")
        target_link_libraries(gfal_test_mkdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)
        
        function(mkdir_test_all name prefix)
            add_test(gfal_mkdir_full_${name} gfal_test_mkdir_full ${prefix})
        endfunction(mkdir_test_all name prefix)    

        # Set credentials test
        add_test_executable(gfal_test_set_creds "gfal_test_set_creds.c")
        target_link_libraries(gfal_test_set_creds ${GFAL2_LIBRARIES})

        function(gfal_test_set_credentials name prefix)
            add_test(gfal_test_set_credentials_${name} gfal_test_set_creds ${prefix})
        endfunction(gfal_test_set_credentials name prefix)    

        # Tests for file transfer
        if(MAIN_TRANSFER)
                
                add_test_executable(gfalt_test_copy_file_cancel "gfalt_test_copy_file_cancel.cpp")
                target_link_libraries(gfalt_test_copy_file_cancel ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} pthread)
                
                add_test_executable(gfalt_test_copy_file "gfalt_test_copy_file.cpp")
                target_link_libraries(gfalt_test_copy_file ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

                add_test_executable(gfalt_test_copy_file_thead_safety "gfalt_test_copy_file_thead_safety.cpp")
                target_link_libraries(gfalt_test_copy_file_thead_safety ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

                add_test_executable(gfalt_test_copy_file_timeout "gfalt_test_copy_file_timeout.cpp")
                target_link_libraries(gfalt_test_copy_file_timeout ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)
                
                add_test_executable(gfalt_test_copy_file_mkdir "gfalt_test_copy_file_mkdir.cpp")
                target_link_libraries(gfalt_test_copy_file_mkdir ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)
                
                add_test_executable(gfalt_test_copy_file_replace "gfalt_test_copy_file_replace.cpp")
                target_link_libraries(gfalt_test_copy_file_replace ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

                add_test_executable(gfalt_test_copy_file_checksum "gfalt_test_copy_file_checksum.cpp")
                target_link_libraries(gfalt_test_copy_file_checksum ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

                add_test_executable(gfalt_test_copy_file_checksum_user "gfalt_test_copy_file_checksum_user.cpp")
                target_link_libraries(gfalt_test_copy_file_checksum_user ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)
                
                add_test_executable(gfalt_test_copy_bulk "gfalt_test_copy_bulk.cpp")
                target_link_libraries(gfalt_test_copy_bulk ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)
                
                function(copy_file_test_full name src_dir dst_dir)
                    add_test(copyfile_checksum_${name} gfalt_test_copy_file_checksum ${src_dir} ${dst_dir})
                    add_test(copyfile_checksum_user_${name} gfalt_test_copy_file_checksum_user ${src_dir} ${dst_dir})
                    add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
                    add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
                    add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
                    add_test(copyfile_bulk_${name} gfalt_test_copy_bulk ${src_dir} ${dst_dir})
                endfunction(copy_file_test_full name dst_dir)

                function(copy_file_test_no_checksum name src_dir dst_dir)
                    add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
                    add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
                    add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
                    add_test(copyfile_bulk_${name} gfalt_test_copy_bulk ${src_dir} ${dst_dir})
                endfunction(copy_file_test_no_checksum name src_dir dst_dir)

                function(copy_file_test_simple name src_dir dst_dir)
                    add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
                endfunction(copy_file_test_simple name src_dir dst_dir)

        endif(MAIN_TRANSFER)

        include(functional-test-parameters.cmake)        

        include(functional-test-parameters.cmake)

        # Install ctest file
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/CTestTestfile.cmake
                DESTINATION ${SHARE_INSTALL_PREFIX}/gfal2/tests)
        
endif(FUNCTIONAL_TESTS)

=== test/unit/CMakeLists.txt ===
add_subdirectory(global)
add_subdirectory(cancel)
add_subdirectory(transfer)
add_subdirectory(uri)
add_subdirectory(plugins/srm)
#add_subdirectory(plugins/gridftp)
add_subdirectory(plugins/xrootd)

=== src/core/config/CMakeLists.txt ===
## default set of build

## defaults sources
FILE(GLOB src_config_f "*.c" )
SET(src_config ${src_config_f} PARENT_SCOPE)

FILE(GLOB header_config "gfal_config.h")

install(FILES ${header_config} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/config)

=== src/core/g_config_manager/CMakeLists.txt ===


FILE(GLOB "src_config_manager" "*.c")

SET(src_g_shared_map "${src_config_manager}" PARENT_SCOPE)

=== debian/changelog ===
gfal2 (2.10.2-1) unstable; urgency=medium

  * New upstream release
  * Add dbg package

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Wed, 02 Dec 2015 17:13:10 +0100

=== debian/control ===
Source: gfal2
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
Build-Depends: debhelper (>= 8.0.0), cmake, doxygen, libglib2.0-dev, libattr1-dev, libldap2-dev, uuid-dev, zlib1g-dev, liblfc-dev, libdpm-dev, srm-ifce-dev (>= 1.23.1), dcap-dev, libglobus-gass-copy-dev, davix-dev (>= 0.4.2), pkg-config, libgtest-dev
Standards-Version: 3.9.6
Section: net
Homepage: http://dmc.web.cern.ch/projects/gfal-2/home

Package: gfal2
Architecture: all
Multi-Arch: foreign
Depends: libgfal2-2, libgfal-transfer2, ${misc:Depends}
Recommends: gfal2-plugin-file, gfal2-plugin-lfc, gfal2-plugin-rfio, gfal2-plugin-dcap, gfal2-plugin-srm, gfal2-plugin-gridftp, gfal2-plugin-http
Description: Grid file access library 2.0
 GFAL 2.0 offers an a single and simple POSIX-like API for the file
 operations in grids and cloud environments. The set of supported
 protocols depends on the gfal2 installed plugins.

Package: libgfal2-2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: gfal2 (<< 2.10.2)
Breaks: gfal2 (<< 2.10.2)
Description: Core of the grid file access library 2.0
 The main library of gfal2. The gfal protocol support relies on a
 plugin system.

Package: libgfal-transfer2
Section: libs
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: File Transfer logic of gfal2
 gfal-transfer is the high level API for file transfer operations in
 gfal2. It supports third-party copy.

Package: libgfal2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), libglib2.0-dev, libattr1-dev, ${misc:Depends}
Description: Development files of gfal2
 Development files for gfal2.

Package: gfal2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Documentation for gfal2
 Documentation, doxygen and examples of gfal2.

Package: gfal2-plugin-file
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Replaces: libgfal2-2 (<< 2.8.4)
Breaks: libgfal2-2 (<< 2.8.4)
Description: Provides file support for gfal2
 Provides the file support (file://) for gfal2. The file plugin
 provides local file operations, as copying from local to remote or
 the other way around.

Package: gfal2-plugin-lfc
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides lfc support for gfal2
 Provides the lfc support (lfn://) for gfal2. The LFC plugin allows
 read-only POSIX operations for the LFC catalog.

Package: gfal2-plugin-rfio
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides rfio support for gfal2
 Provides the rfio support (rfio://) for gfal2. The rfio plugin
 provides the POSIX operations for the rfio URLs, the rfio protocol is
 used on the DPM and on the Castor storage systems.

Package: gfal2-plugin-dcap
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), dcap-tunnel-gsi, ${shlibs:Depends}, ${misc:Depends}
Description: Provides dcap support for gfal2
 Provides the dcap support (gsidcap://, dcap://) for gfal2. The dcap
 plugin provides the POSIX operations for the dcap URLs, the dcap
 protocol is used on the DCACHE storage system.

Package: gfal2-plugin-srm
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), libgfal-srm-ifce1 (>= 1.23.1), ${shlibs:Depends}, ${misc:Depends}
Description: Provides srm support for gfal2
 Provides the srm support (srm://) for gfal2. The srm plugin provides
 the POSIX operations and the third party transfer support on the SRM
 URLs.

Package: gfal2-plugin-gridftp
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides the gridftp support for gfal2
 Provides the gridftp support (gsiftp://) for gfal2. The gridftp plugin
 provides the POSIX operations and the third party transfer support on
 the GSIFTP URLs.

Package: gfal2-plugin-http
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides HTTP and DAV support for gfal2
 Provides the HTTP (http[s]://) and WebDAV (dav[s]://) support for
 gfal2. This plugin is able to do third-party copy with WebDAV if the
 storage supports it.

Package: gfal2-plugin-mock
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides a mock dummy protocol for gfal2
 Provides a dummy mock:// protocol for gfal2.

Package: gfal2-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libgfal2-2 (= ${binary:Version}) | libgfal-transfer2 (= ${binary:Version}) | gfal2-plugin-file (= ${binary:Version}) | gfal2-plugin-lfc (= ${binary:Version}) | gfal2-plugin-rfio (= ${binary:Version}) | gfal2-plugin-dcap (= ${binary:Version}) | gfal2-plugin-srm (= ${binary:Version}) | gfal2-plugin-gridftp (= ${binary:Version}) | gfal2-plugin-http (= ${binary:Version}) | gfal2-plugin-mock (= ${binary:Version})
Description: Debug symbols for the gfal 2.0 library and its plugins
 Debug symbols for the grid file access library 2.0 and its plugins.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	ln -fs /usr/src/gtest test/gtest
	dh_auto_configure -- -DSYSCONF_INSTALL_DIR:PATH=/etc \
	   -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	   -DUNIT_TESTS=TRUE -DPLUGIN_XROOTD=FALSE -DPLUGIN_MOCK=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_install:
	mkdir -p debian/gfal2-doc/usr/share/doc/gfal2-doc
	mv debian/tmp/usr/share/doc/gfal2/examples \
	   debian/tmp/usr/share/doc/gfal2/html \
	   debian/gfal2-doc/usr/share/doc/gfal2-doc
	rm -rf debian/tmp/usr/share/doc
	# Replace with a script for multi-arch
	printf '#!/bin/sh\necho ' > debian/tmp/usr/bin/gfal2_version.sh
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$${LD_LIBRARY_PATH} \
	   debian/tmp/usr/bin/gfal2_version >> \
	   debian/tmp/usr/bin/gfal2_version.sh
	mv debian/tmp/usr/bin/gfal2_version.sh \
	   debian/tmp/usr/bin/gfal2_version
	dh_install --fail-missing

override_dh_strip:
	dh_strip --dbg-package gfal2-dbg

override_dh_auto_clean:
	rm -f test/gtest
	dh_auto_clean

override_dh_auto_test:
	objdir=`ls -d obj-*` ; \
	export GFAL_PLUGIN_DIR=$(CURDIR)/$${objdir}/plugins ; \
	export GFAL_CONFIG_DIR=$(CURDIR)/$${objdir}/test/conf_test ; \
	dh_auto_test -- "ARGS+=-V"

## gfal2 2.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,8 +43,8 @@
 set (OUTPUT_NAME_TRANSFER "gfal_transfer")
 
 set (VERSION_MAJOR  2)
-set (VERSION_MINOR  10)
-set (VERSION_PATCH  2)
+set (VERSION_MINOR  11)
+set (VERSION_PATCH  1)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 add_definitions(-DVERSION="${VERSION_STRING}")

=== src/utils/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

# Dependencies
if (IS_IFCE)
    list (APPEND gfal2_utils_definitions "-DMDS_BDII_EXTERNAL=1")
    set (is_ifce_link "is_ifce")
    list (APPEND src_mds "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds.c")
else (IS_IFCE)
    list (APPEND gfal2_utils_definitions "-DMDS_BDII_EXTERNAL=0")
    list (APPEND is_ifce_link "ldap_r" "lber")
    list (APPEND src_mds
        "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds.c"
        "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds_internal.c"
        "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds_ldap_internal_layer.c"
    )
endif (IS_IFCE)

find_package (PugiXML)
if (NOT PUGIXML_FOUND)
    message ("PugiXML not found. MDS Cache disabled")
    list (APPEND gfal2_utils_definitions "-DMDS_WITHOUT_CACHE=1")
    set (mds_cache_link "")
else (NOT PUGIXML_FOUND)
    list (APPEND src_mds
        "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds_cache.cpp"
    )
    set (mds_cache_link "${PUGIXML_LIBRARIES}")
endif (NOT PUGIXML_FOUND)

# Link
list (APPEND gfal2_utils_libraries
    ${is_ifce_link}
    ${mds_cache_link}
)

# Sources
file (GLOB src_exceptions   "${CMAKE_CURRENT_SOURCE_DIR}/exceptions/*.c*")
file (GLOB src_gsimplecache "${CMAKE_CURRENT_SOURCE_DIR}/gsimplecache/*.c*")
file (GLOB src_uri          "${CMAKE_CURRENT_SOURCE_DIR}/uri/*.c*")
file (GLOB src_checksums    "${CMAKE_CURRENT_SOURCE_DIR}/checksums/*.c*")

list (APPEND gfal2_utils_src ${src_exceptions})

list (APPEND gfal2_utils_c_src
    ${src_gsimplecache}
    ${src_uri}
    ${src_checksums}
    ${src_mds}
)

set (gfal2_utils_c_src ${gfal2_utils_c_src} PARENT_SCOPE)
set (gfal2_utils_src ${gfal2_utils_src} PARENT_SCOPE)
set (gfal2_utils_libraries ${gfal2_utils_libraries} PARENT_SCOPE)
set (gfal2_utils_definitions ${gfal2_utils_definitions} PARENT_SCOPE)

# Install public headers
install (FILES "uri/gfal_uri.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/utils)

=== test/functional/CMakeLists.txt ===
function (add_test_executable name source)
add_executable(${name} ${source})
install(TARGETS ${name}
        DESTINATION ${SHARE_INSTALL_PREFIX}/gfal2/tests)
endfunction(add_test_executable name)


if(FUNCTIONAL_TESTS)
    find_package(GTEST)

    include_directories(
        "${CMAKE_SOURCE_DIR}/src"
        "${CMAKE_SOURCE_DIR}/test"
        "${CMAKE_SOURCE_DIR}/src/posix/"
        "${GLIB2_INCLUDE_DIRS}"
        "${GTEST_INCLUDE_DIR}"
    )

    # Bring online tests
    add_test_executable(gfal_test_bringonline "gfal_test_bringonline.cpp")
    target_link_libraries(gfal_test_bringonline ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_bringonline name dir_path)
        add_test(gfal_test_bringonline_${name} gfal_test_bringonline ${dir_path})
    endfunction(test_bringonline name valid_file)

    # Checksum tests
    add_test_executable(gfal_test_checksum "gfal_test_checksum.cpp")
    target_link_libraries(gfal_test_checksum ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_checksum_simple name dir_path algo)
        add_test(gfal_checksum_simple_${name} gfal_test_checksum ${dir_path} ${algo})
    endfunction(test_checksum_simple name valid_file algo)

    # Stat tests
    add_test_executable(gfal_test_stat "gfal_test_stat.c")
    target_link_libraries(gfal_test_stat ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_stat_all name valid)
        add_test(gfal_stat_${name} gfal_test_stat ${valid})
    endfunction(test_stat_all valid)

    # Access test
    add_test_executable(gfal_test_access "gfal_test_access.cpp")
    target_link_libraries(gfal_test_access ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_access name dir_path)
        add_test(gfal_test_access_${name} gfal_test_access ${dir_path})
    endfunction(test_access name dir_path)

    # XAttr test
    add_test_executable(gfal_test_xattr "gfal_test_xattr.cpp")
    target_link_libraries(gfal_test_xattr ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_xattr name dir_path)
        add_test(gfal_test_xattr_${name} gfal_test_xattr ${dir_path} ${ARGV2})
    endfunction(test_xattr name dir_path)

    # Deletion tests
    add_test_executable(gfal_test_del_nonex "gfal_test_del_nonex.c")
    target_link_libraries(gfal_test_del_nonex ${GFAL2_LIBRARIES} gfal2_test_shared)

    add_test_executable(gfal_test_del "gfal_test_del.cpp")
    target_link_libraries(gfal_test_del ${GFAL2_LIBRARIES} gfal2_test_shared)

    add_test_executable(gfal_test_mkdir_unlink "gfal_test_mkdir_unlink.c")
    target_link_libraries(gfal_test_mkdir_unlink ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_del_nonex name dir_path)
        add_test(gfal_test_del_nonex_${name} gfal_test_del_nonex ${dir_path})
    endfunction(test_del_nonex name path)

    function(test_del name dir_path)
        add_test(gfal_test_del_${name} gfal_test_del ${dir_path})
    endfunction(test_del name path)

    function (test_mkdir_unlink name dir_path)
        add_test(gfal_test_mkdir_unlink_${name} gfal_test_mkdir_unlink ${dir_path})
    endfunction (test_mkdir_unlink name path)

    # Rename tests
    add_test_executable(gfal_test_rename "gfal_test_rename.cpp")
    target_link_libraries(gfal_test_rename ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_rename name dir_path)
        add_test(gfal_test_rename_${name} gfal_test_rename ${dir_path})
    endfunction(test_rename name dir_path)

    # Chmod tests
    add_test_executable(gfal_test_chmod "gfal_test_chmod.cpp")
    target_link_libraries(gfal_test_chmod ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_chmod_all name valid right1 right2 right3 right4)
        add_test(gfal_test_right_change_${name} gfal_test_chmod ${valid} ${right1} ${right2} ${right3} ${right4})
    endfunction(test_chmod_all name valid right1 right2 right3 right4)

    # Rmdir tests
    add_test_executable(gfal_test_rmdir_full "gfal_test_rmdir_full.cpp")
    target_link_libraries(gfal_test_rmdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_rmdir_all name valid_dir)
        add_test(gfal_test_rmdir_full_${name} gfal_test_rmdir_full ${valid_dir})
    endfunction(test_rmdir_all name valid_dir)

    # Readdir tests
    add_test_executable(gfal_test_readdir_full "gfal_test_readdir_full.cpp")
    target_link_libraries(gfal_test_readdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_readdir_full name valid)
            add_test(gfal_test_readdir_full_${name} gfal_test_readdir_full ${valid})
    endfunction(test_readdir_full valid)

    # IO tests
    add_test_executable(gfal_test_rw_full "gfal_test_rw_full.cpp")
    target_link_libraries(gfal_test_rw_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    add_test_executable(gfal_test_rw_seq "gfal_test_rw_seq.cpp")
    target_link_libraries(gfal_test_rw_seq ${GFAL2_LIBRARIES} gfal2_test_shared)

    add_test_executable(gfal_test_rw_seek "gfal_test_rw_seek.cpp")
    target_link_libraries(gfal_test_rw_seek ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_rwt_all name path size)
        add_test(gfal_rw_size_${name} gfal_test_rw_full ${path} ${size})
    endfunction(test_rwt_all name path size)

    function(test_rwt_seq name path size_read size)
        add_test(gfal_rw_seq_${name} gfal_test_rw_seq ${path} ${size_read} ${size})
    endfunction(test_rwt_seq name path size_read size)

    function(test_rwt_seek name path size_read size)
        add_test(gfal_rw_seek_${name} gfal_test_rw_seek ${path} ${size_read} ${size})
    endfunction(test_rwt_seek name path size)

    # Mkdir tests
    add_test_executable(gfal_test_mkdir_full "gfal_test_mkdir_full.cpp")
    target_link_libraries(gfal_test_mkdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_mkdir_all name prefix)
        add_test(gfal_mkdir_full_${name} gfal_test_mkdir_full ${prefix})
    endfunction(test_mkdir_all name prefix)

    # Register test
    add_test_executable(gfal_test_register "gfal_test_register.cpp")
    target_link_libraries(gfal_test_register ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_register name origin lfc)
        add_test(gfal_test_register_${name} gfal_test_register ${origin} ${lfc})
    endfunction(test_register name origin lfc)

    # Set credentials test
    add_test_executable(gfal_test_set_creds "gfal_test_set_creds.c")
    target_link_libraries(gfal_test_set_creds ${GFAL2_LIBRARIES})

    function(gfal_test_set_credentials name prefix)
        add_test(gfal_test_set_credentials_${name} gfal_test_set_creds ${prefix})
    endfunction(gfal_test_set_credentials name prefix)

    # Posix test
    add_test_executable(gfal_test_posix "gfal_test_posix.cpp")
    target_link_libraries(gfal_test_posix ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(gfal_test_posix name prefix)
        add_test(gfal_test_posix_${name} gfal_test_posix ${prefix})
    endfunction(gfal_test_posix name prefix)

    # Tests for file transfer
    if(MAIN_TRANSFER)

        add_test_executable(gfalt_test_copy_file_cancel "gfalt_test_copy_file_cancel.cpp")
        target_link_libraries(gfalt_test_copy_file_cancel ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} pthread)

        add_test_executable(gfalt_test_copy_file "gfalt_test_copy_file.cpp")
        target_link_libraries(gfalt_test_copy_file ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_thead_safety "gfalt_test_copy_file_thead_safety.cpp")
        target_link_libraries(gfalt_test_copy_file_thead_safety ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_timeout "gfalt_test_copy_file_timeout.cpp")
        target_link_libraries(gfalt_test_copy_file_timeout ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_mkdir "gfalt_test_copy_file_mkdir.cpp")
        target_link_libraries(gfalt_test_copy_file_mkdir ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_replace "gfalt_test_copy_file_replace.cpp")
        target_link_libraries(gfalt_test_copy_file_replace ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_checksum "gfalt_test_copy_file_checksum.cpp")
        target_link_libraries(gfalt_test_copy_file_checksum ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_checksum_user "gfalt_test_copy_file_checksum_user.cpp")
        target_link_libraries(gfalt_test_copy_file_checksum_user ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_bulk "gfalt_test_copy_bulk.cpp")
        target_link_libraries(gfalt_test_copy_bulk ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_pasv "gfalt_test_pasv.cpp")
        target_link_libraries(gfalt_test_pasv ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        function(test_copy_file_full name src_dir dst_dir)
            add_test(copyfile_checksum_${name} gfalt_test_copy_file_checksum ${src_dir} ${dst_dir})
            add_test(copyfile_checksum_user_${name} gfalt_test_copy_file_checksum_user ${src_dir} ${dst_dir})
            add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
            add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
            add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
            add_test(copyfile_bulk_${name} gfalt_test_copy_bulk ${src_dir} ${dst_dir})
        endfunction(test_copy_file_full name dst_dir)

        function(test_copy_file_no_checksum name src_dir dst_dir)
            add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
            add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
            add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
            add_test(copyfile_bulk_${name} gfalt_test_copy_bulk ${src_dir} ${dst_dir})
        endfunction(test_copy_file_no_checksum name src_dir dst_dir)

        function(test_copy_file_simple name src_dir dst_dir)
            add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
        endfunction(test_copy_file_simple name src_dir dst_dir)

        function(test_pasv name src_dir dst_dir)
            add_test(gfalt_test_pasv_${name} gfalt_test_pasv ${src_dir} ${dst_dir})
        endfunction(test_pasv name src_dir dst_dir)

    endif(MAIN_TRANSFER)

    include(functional-test-parameters.cmake)

    include(functional-test-parameters.cmake)

    # Install ctest file
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/CTestTestfile.cmake
            DESTINATION ${SHARE_INSTALL_PREFIX}/gfal2/tests)

endif(FUNCTIONAL_TESTS)

=== test/unit/CMakeLists.txt ===
add_subdirectory(global)
add_subdirectory(cancel)
add_subdirectory(transfer)
add_subdirectory(uri)

=== debian/changelog ===
gfal2 (2.11.1-1) unstable; urgency=medium

  * New upstream release

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Tue, 10 May 2016 18:01:02 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
 Build-Depends: debhelper (>= 8.0.0), cmake, doxygen, libglib2.0-dev, libattr1-dev, libldap2-dev, uuid-dev, zlib1g-dev, liblfc-dev, libdpm-dev, srm-ifce-dev (>= 1.23.1), dcap-dev, libglobus-gass-copy-dev, davix-dev (>= 0.4.2), pkg-config, libgtest-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: net
 Homepage: http://dmc.web.cern.ch/projects/gfal-2/home
